Goals are groups of triggers that have matched some business criteria based on rules.
| Property | Description |
|---|---|
| goalId (integer) | An integer with the Goal ID. |
| goalTitle (string) | Title of the Goal. |
| goalDescription (string) | Description of the Goal. |
| goalOrder (integer) | An integer detailing the order of the goals. |
| deDupeFields (array) | An array of comma delimited values. |
| deDupeLookback (integer) | An integer with the number of days deduplication is applied. |
| goalStatus (integer) | An integer representing goal status: 200 - active, 410 - inactive. |
| criteriaConfig (array) | Array of criteria (each containing a field, op, and value). |
| actionConfig (array) | Optional array of actions (each containing a mode and/or args). |
Goal ranges are now DEPRECATED - use the criteriaConfig and actionConfig properties of the goal instead
| Property | Description |
|---|---|
| criteria (array) | Array of criteria (each containing a field, op, and value). |
| action (array) | Optional array of actions (each containing a mode and/or args). |
| startDatetime (datetime) | Datetime. |
Goal criteria fields may be any of those defined in the trigger reports (see Field Definitions), except for the following fields:
This lists the Goals configured for an IGRP.
GET /config/v2/igrps/{IGRP SPECIFIER}/goals
URL Path Params
| Property | Description |
|---|---|
| IGRP SPECIFIER (int) | Installation ID. |
GET Params
| Property | Description |
|---|---|
| filter (array) OPTIONAL |
One or more filters. |
| sort (array) OPTIONAL |
One or more sorting params. |
| limit (integer) OPTIONAL |
Limit on the result set. |
| offset (integer) OPTIONAL |
|
| includeDeleted (int) OPTIONAL |
A flag (1 or 0) to show deleted goals on the request. Defaults to 0. |
Filter Types
The Goals list may be filtered by any of the returned fields. Additionally Goals can be filtered by goalGroupId and goalGroupTypeId.
Sort Types
The Goals list may be sorted by any of the returned fields. Additionally Goals can be sorted by goalGroupId and goalGroupTypeId.
Returns a list of Goals.
| Property | Description |
|---|---|
| goalId (integer) | Goal ID. |
| goalTitle (string) | Goal Title. |
| goalDescription (string) | Goal Description. |
| goalOrder (integer) | Goal Order number. |
| deDupeFields (array) | An array of fields. |
| deDupeLookbackDays (integer) | An integer with the number of days deduplication is applied. |
| goalStatus (integer) | Goal status. See goal properties. |
| criteriaConfig (array) | Array of criteria (each containing a field, op, and value). |
| actionConfig (array) | Optional array of actions (each containing a mode and/or args). |
{"goalId":"100","goalTitle":"Call Pass","goalDescription":"Test goal 1","goalOrder":"0","deDupeFields":[["test1"]],"deDupeLookbackDays":"60","goalStatus":200,"actionConfig":[{"mode":"test","args":"test"}],"criteriaConfig":[{"field":"act","op":"eq","value":"call"}]}
{"goalId":"101","goalTitle":"New Goal","goalDescription":"Test goal 2","goalOrder":"1","deDupeFields":[["test2"]],"deDupeLookbackDays":"30","goalStatus":410,"actionConfig":[{"mode":"test","args":"test"}],"criteriaConfig":[{"field":"act","op":"eq","value":"call"}]}
Read Goal details for the specified Goal and IGRP.
GET /config/v2/igrps/{IGRP SPECIFIER}/goals/{GOAL SPECIFIER}
URL Path Params
| Property | Description |
|---|---|
| IGRP SPECIFIER (int) | Installation ID. |
| GOAL SPECIFIER (int) | Goal ID. |
{"goalId":"2","goalTitle":"testGoal","goalDescription":"testDesc","goalOrder":"2","deDupeFields":[["vid"]],"deDupeLookbackDays":"90","goalStatus":200,"actionConfig":[{"mode":"test","args":"test"}],"criteriaConfig":[{"field":"act","op":"eq","value":"call"}]}
This creates a new Goal for an IGRP.
POST /config/v2/igrps/{IGRP SPECIFIER}/goals
URL Path Params
| Property | Description |
|---|---|
| IGRP SPECIFIER (int) | Installation ID. |
POST Params
| Property | Description |
|---|---|
| goalTitle (string) | Title of the Goal. |
| goalDescription (string) | Description of the Goal. |
| goalOrder (int) | Goal Order number. |
| deDupeFields (array) | An array of fields |
| deDupeLookbackDays (int) | The number of days deduplication is applied. |
| goalStatus (integer) OPTIONAL |
Goal status. Default: 200. |
| criteriaConfig (array) OPTIONAL |
Array of criteria (each containing a field, op, and value). |
| actionConfig (array) OPTIONAL |
Optional array of actions (each containing a mode and/or args). |
{"goalId":"2"}
Updates the configuration of an existing Goal.
POST /config/v2/igrps/{IGRP SPECIFIER}/goals/{GOAL SPECIFIER}
URL Path Params
| Property | Description |
|---|---|
| IGRP SPECIFIER (int) | Installation ID. |
| GOAL SPECIFIER (int) | Goal ID. |
POST Params
| Property | Description |
|---|---|
| goalTitle (string) | Title of the Goal. |
| goalDescription (string) | Description of the Goal. |
| goalOrder (int) | Goal Order number. |
| deDupeFields (array) | An array of fields |
| deDupeLookbackDays (int) | The number of days deduplication is applied. |
| criteriaConfig (array) OPTIONAL |
Array of criteria (each containing a field, op, and value). |
| actionConfig (array) OPTIONAL |
Optional array of actions (each containing a mode and/or args). |
Returns the HTTP 204 (No Content) status code if update successful.
HTTP 204 - NO CONTENT
Remove existing Goal.
DELETE /config/v2/igrps/{IGRP SPECIFIER}/goals/{GOAL SPECIFIER}
Goal Params
| Property | Description |
|---|---|
| IGRP SPECIFIER (int) | Installation ID. |
| GOAL SPECIFIER (int) | Goal ID. |
Returns the HTTP 204 (No Content) status code if delete successful.
HTTP 204 - NO CONTENT
Sets the goals order.
PUT /config/v2/igrps/{IGRP SPECIFIER}/goals/order
URL Path Params
| Property | Description |
|---|---|
| IGRP SPECIFIER (int) | Installation ID. |
PUT Params
| Property | Description |
|---|---|
| sortedGoals (array) | Array of goal IDs, with the array index to be used as the order. |
HTTP 204 - NO CONTENT
Required Criteria
All goals require an action set in the criteria to define what actions the goal should be triggered for. See examples below
Visits to a particular page
{"criteria":[{"field":"act","op":"in","value":"land,page"},{"field":"href","op":"eq","value":"http://www.example.com/some/page.html"}]}
Calls over 60 seconds
{"criteria":[{"field":"act","op":"eq","value":"call"},{"field":"bridgeDuration","op":"gt","value":"60"}]}
Returns the HTTP response code to reflect the request outcome.
HTTP 204 - NO CONTENT